
import 'dart:io';
import 'package:pubinit/src/yaml.dart';
import 'package:pubinit/src/pubspecwriter.dart';

/**
 *
 */
void main(List<String> args) {
  var userName = Platform.environment['username'].trim();

  stdout.write('Pub init utility by Ophélien "Shalien" DUPARC\n\r');

  var values = new Map<String, String>();

  values['name'] =
      Directory.current.path.split(Platform.pathSeparator).removeLast();
  values['version'] = '0.0.1';
  values['description'] = '';
  values['author'] = '$userName <$userName@example.com>';
  values['homepage'] = 'https://www.example.com';

  var input = '';

  //NAME
  stdout.write('name [${values['name']}]:');
  input = stdin.readLineSync();

  if (input
      .trim()
      .length > 0) {
    values['name'] = input;
  }

  //VERSION
  stdout.write('version [${values['version']}]:');
  input = stdin.readLineSync();

  if (input
      .trim()
      .length > 0) {
    values['version'] = input;
  }

  //DESCRIPTION
  stdout.write('description: ');
  values['description'] = stdin.readLineSync();

  //AUTHOR
  stdout.write('author [${values['author']}]: ');
  input = stdin.readLineSync();

  if (input
      .trim()
      .length > 0) {
    values['author'] = input;
  }

  //HOMEPAGE
  stdout.write('homepage [${values['homepage']}]:');
  values['homepage'] = stdin.readLineSync();

  var yaml = YAML.encode(values);
  stdout.write('\n\n$yaml\n\nIs this valid ? [yes]');

  input = stdin.readLineSync();

  if (input
      .trim()
      .length > 0) {
    switch (input.substring(0, 1).toLowerCase()) {
      case 'y':
        PubspecWriter.write(yaml);
        break;
      case 'n':
        print('CANCELLED');
        return;
        break;
    }
  } else {
    PubspecWriter.write(yaml);
  }

}